;******************************************************
;                All rights reserved.
;******************************************************

        INCLUDE TPCOMMON.ASM

;****************************************************** Code

CODE    SEGMENT BYTE PUBLIC

        ASSUME  CS:CODE

        PUBLIC  Optimize
        PUBLIC  WildEqStr

;******************************************************

;function Optimize(S : string) : string;

Optimize        PROC FAR

        StackFrameBP                            ;set up stack frame
        CLD                                     ;go forward
        PUSH    DS                              ;save DS
        GetDSPtr        SS:[BP+6]               ;DS:SI => input string
        GetPtr          SS:[BP+10]               ;ES:DI => function result
        LODSB                                   ;AL = Length(S)
        MOV     DL,AL                           ;DL = Length(S) for processing
        MOV     BX,DI                           ;in BX saved DI,pointed on
                                                ;result length
	STOSB
        SetZero CH                              ;CH = 0
        MOV     CL,AL                           ;CX = Length(S)
        JCXZ    Done                            ;Done if CX is 0
        MOV     DH,' '                          ;DH is used like
                                                ;temp 1 byte stack(TStack)

LOOP1:
        LODSB                                   ;Next char into AL
        CMP     AL,'*'                          ;AL = '*' ?
        JE      M1                              ;If so, goto processing
        CMP     DH,' '                          ;TStack clear ?
        JE      M2                              ;
        CMP     AL,'?'                          ;
        JE      M2                              ;
        XCHG    DH,AL                           ;
        STOSB                                   ;
        INC     DL                              ;
        MOV     AL,DH                           ;
        MOV     DH,' '                          ;
M2:
        STOSB
        JMP     M3
M1:
        MOV     DH,AL
        DEC     DL
M3:
        LOOP    LOOP1
        CMP     DH,' '                          ;AH > 'z'?
        JE      Done
        MOV     AL,DH
        STOSB
        INC     DL

Done:
        MOV     DI,BX
        MOV     AL,DL
        STOSB
        POP     DS
        ExitCode 4

Optimize        ENDP

;******************************************************

;function WildEqStr(W,S : string) : boolean;

WildEqStr    PROC FAR

        StackFrameBP                    ;set up stack frame
        CLD                             ;go forward
        PUSH    DS                      ;save DS
        GetDSPtr        SS:[BP+10]       ;DS:SI => WildCard
        GetPtr          SS:[BP+6]       ;ES:DI => Test string
        PUSH    DS
        PUSH    ES
        POP     DS
        XCHG    SI,DI
        LODSB
        MOV     BH,AL                   ;BH = Length(S)
        POP     DS
        XCHG    SI,DI

        LODSB                           ;AL = Length(W)
        SetZero CH                      ;CH = 0
        MOV     CL,AL                   ;CX = Length(S)
        MOV     BL,AL                   ;BL = Length(W)
        CMP     CL,BH                   ;compare length(W) and length(S)
        JA      FalseRes                ;false if WC is longer



CLOOP:
        REPE    CMPSB                   ;comparing...
        JE      TestRes                 ;if Eq then Test Results
;------ mismatch detected --------
;---- first recount BH and BL ----
        ADD     BH,CL
        SUB     BH,BL
        MOV     BL,CL

        DEC     SI                      ;look for mismatched symbol
        LODSB                           ;AL = first mismatch
        CMP     AL,'?'                  ;AL = '?' ?
        JE      CLOOP                   ;If so, continue
        CMP     AL,'*'                  ;AL = '*' ?
        JNE     FalseRes                ;if not '*' ,comparison failed
;------ '*' found ----------------
	JCXZ	TrueRes			;if CX = 0 then '*' is last symbol
        LODSB                           ;AL - first WC symbol after '*'
	DEC	DI
	DEC	CL
	MOV	BL,CL
        XCHG    CL,BH
        REPNE   SCASB
        JNE     FalseRes                ;if symbol in AL not found in S - failed
        XCHG    BH,CL
        JMP     CLOOP

TestRes:
;------ WC is ended.If S is ended two then O'K ----
        CMP     BL,BH
        JNE     FalseRes

TrueRes:
        MOV     AL,True
        JMP     CDone

FalseRes:
        MOV     AL,False

CDone:
        POP     DS
        ExitCode 4

WildEqStr   ENDP


CODE    ENDS

        END


